//
//  Gob1MenuViewController.m
//  scummvm
//
//  Created by DotEmu on 17/05/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#include <semaphore.h>

#import <engines/igob/gob.h>
#import "switchViewController.h"
#import "iPhoneViewController.h"
#import "Gob1MenuViewController.h"
#import "iphone_main.h"

//////////////////
//---GAME PARAMS
//GAME (GENERAL)
extern bool bMenuGob1;
extern bool bFromMenuIngame;
//LVL (SIMULATION)
extern bool bSimulation;
//SOUND
extern bool bSoundMusicActive;
extern int idSoundMusic;
extern int idSoundSFX;
extern AVAudioPlayer* audioPlayer;
AVAudioPlayer* menuPlayer;
//DEFINE
extern bool bSleepMode;
extern bool bSem;
extern sem_t* sem;
extern switchViewController* g_switchVC;
extern iPhoneViewController* g_iVC;
//---END
////////////////

@implementation Gob1MenuViewController
@synthesize _creditsVC, _helpVC, _settingsVC, _loadVC;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil 
{
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) 
	{
        // Custom initialization
    }
    return self;
}*/


-(void)plan1FinishedLeft:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context 
{	
	if( bAnimationOn )
	{
		if( ppal1 != nil )
			ppal1.frame = CGRectMake( 553, 20, 73, 64 );		
		else 
			ppal1 = [[UIImageView alloc] initWithFrame:CGRectMake( 553, 20, 73, 64 )];
		
		ppal1.hidden = NO;
		[UIView beginAnimations:nil context:self]; 
		{
			[UIView setAnimationDuration:42];
			[UIView setAnimationDelegate:self];
			[UIView setAnimationCurve:UIViewAnimationCurveLinear];
			[UIView setAnimationDidStopSelector:@selector(plan1FinishedLeft:finished:context:)];
			ppal1.frame = CGRectMake( -73, 20, 73, 64 );
		}
		[UIView commitAnimations];
	}
	else
	{
		//NSLog(@"plan 1 hidden");		
		ppal1.hidden = YES;
	}
}

-(void)launchAnim_Plan1
{
	if( bAnimationOn )
	{
		//NSLog(@"plan 1");
		if( ppal1 != nil )
			ppal1.frame = CGRectMake( 188, 20, 73, 64 );		
		else 
			ppal1 = [[UIImageView alloc] initWithFrame:CGRectMake( 188, 20, 73, 64 )];
		
		ppal1.hidden = NO;
		[UIView beginAnimations:nil context:self]; 
		{
			[UIView setAnimationDuration:24];
			[UIView setAnimationDelegate:self];
			[UIView setAnimationCurve:UIViewAnimationCurveLinear];
			[UIView setAnimationDidStopSelector:@selector(plan1FinishedLeft:finished:context:)];
			ppal1.frame = CGRectMake( -73, 20, 73, 64 );
		}
		[UIView commitAnimations];
	}
	else
	{
		//NSLog(@"plan 1 hidden");		
		ppal1.hidden = YES;
	}
}

-(void)plan3FinishedLeft:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context 
{	
	if( bAnimationOn )
	{
		if( ppal3 != nil )
			ppal3.frame = CGRectMake( 559, 6, 79, 51 );		
		else 
			ppal3 = [[UIImageView alloc] initWithFrame:CGRectMake( 559, 6, 79, 51 )];

		ppal3.hidden = NO;
		[UIView beginAnimations:nil context:self]; 
		{
			[UIView setAnimationDuration:50];
			[UIView setAnimationDelegate:self];
			[UIView setAnimationCurve:UIViewAnimationCurveLinear];
			[UIView setAnimationDidStopSelector:@selector(plan3FinishedLeft:finished:context:)];
			ppal3.frame = CGRectMake( -79, 6, 79, 51 );
		}
		[UIView commitAnimations];
	}
	else
	{
		//NSLog(@"plan 3 hidden");		
		ppal3.hidden = YES;
	}
}

-(void)launchAnim_Plan3
{
	if( bAnimationOn )
	{
		//NSLog(@"plan 3");
		if( ppal3 != nil )
			ppal3.frame = CGRectMake( 375, 6, 79, 51 );		
		else 
			ppal3 = [[UIImageView alloc] initWithFrame:CGRectMake( 375, 6, 79, 51 )];		

		ppal3.hidden = NO;
		[UIView beginAnimations:nil context:self]; 
		{
			[UIView setAnimationDuration:48];
			[UIView setAnimationDelegate:self];
			[UIView setAnimationCurve:UIViewAnimationCurveLinear];
			[UIView setAnimationDidStopSelector:@selector(plan3FinishedLeft:finished:context:)];
			ppal3.frame = CGRectMake( -79, 6, 79, 51 );
		}
		[UIView commitAnimations];
	}
	else
	{
		//NSLog(@"plan 3 hidden");	
		ppal3.hidden = YES;
	}
}

////-----ANIM END----
///////-------------

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad 
{
	//NSLog(@"Gob1MenuViewController viewDidLoad");
    [super viewDidLoad]; 
	
	NSURL *url = [NSURL fileURLWithPath:[NSString stringWithFormat:@"%@/music_menu_48.mp3", [[NSBundle mainBundle] resourcePath]]];
	NSError *err;
	if( menuPlayer == nil )
	{
		menuPlayer = [[AVAudioPlayer alloc] initWithContentsOfURL:url error:&err];			 
	}
	
	//Si on a la musique du jeu d'active
	if( bSoundMusicActive )
	{
		if( menuPlayer != nil )
		{
			[menuPlayer stop];
			[audioPlayer stop];
			menuPlayer.currentTime = 0;
			menuPlayer.volume = (float)((float)idSoundMusic / 256.0f);
			menuPlayer.numberOfLoops = -1;
			if( self.view.alpha == 1 )
				[menuPlayer play]; 				
		}
	}
	
	// Emulated CD support through MP3
	url = [NSURL fileURLWithPath:[NSString stringWithFormat:@"%@/button-25.mp3", [[NSBundle mainBundle] resourcePath]]];

	menuSFXPlayer = [[AVAudioPlayer alloc] initWithContentsOfURL:url error:&err];
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	menuSFXPlayer.numberOfLoops = 0;
	
	//ANIMATION
	bAnimationOn = true;
	
	[self launchAnim_Plan1];
	[self launchAnim_Plan3];
	
	//NOTIFICATIONS
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(pauseAnimNotification)  name:@"pauseAnimNotif" object:nil];	
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(resumeAnimNotification)  name:@"resumeAnimNotif" object:nil];	
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(stopAnimNotification)  name:@"stopAnimNotif" object:nil];	
	[[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(startAnimNotification)  name:@"startAnimNotif" object:nil];		
}

///----NOTIFICATIONS
-(void)pauseAnimNotification
{
	[self performSelectorOnMainThread:@selector(pauseAnim) withObject: nil waitUntilDone:NO];
}

-(void)resumeAnimNotification
{
	[self performSelectorOnMainThread:@selector(resumeAnim) withObject: nil waitUntilDone:NO];
}

-(void)stopAnimNotification
{
	[self performSelectorOnMainThread:@selector(stopAnim) withObject: nil waitUntilDone:NO];
}

-(void)startAnimNotification
{
	[self performSelectorOnMainThread:@selector(startAnim) withObject: nil waitUntilDone:NO];
}

-(void)pauseAnim
{
	//NSLog(@"Stop Anim");
	ppal1.hidden = YES;	
	ppal3.hidden = YES;
}

-(void)resumeAnim
{
	//NSLog(@"Start Anim");
	ppal1.hidden = NO;	
	ppal3.hidden = NO;
}

-(void)stopAnim
{
	//NSLog(@"Stop Anim");
	bAnimationOn = false;
}

- (void) startAnim
{
	//NSLog(@"Start Anim");
	bAnimationOn = true;
	[self launchAnim_Plan1];
	[self launchAnim_Plan3];
}

// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation 
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationLandscapeLeft || interfaceOrientation == UIInterfaceOrientationLandscapeRight );
}

-(void) releaseView
{
	//NSLog(@"Gob1MenuViewController releaseView");
	if( _loadVC.view.superview != nil )
	{
		if( _creditsVC != nil && _creditsVC.view != nil )
		{
			[_creditsVC.view removeFromSuperview];
			[_creditsVC release];
			_creditsVC = nil;
		}
		if( _helpVC != nil && _helpVC.view != nil )
		{
			[_helpVC.view removeFromSuperview];
			[_helpVC release];
			_helpVC = nil;
		}
		if( _settingsVC != nil && _settingsVC.view != nil )
		{
			[_settingsVC.view removeFromSuperview];
			[_settingsVC release];
			_settingsVC = nil;
		}
	}
	else if( _creditsVC.view.superview != nil )
	{
		if( _loadVC != nil && _loadVC.view != nil )
		{
			[_loadVC.view removeFromSuperview];
			[_loadVC release];
			_loadVC = nil;
		}
		if( _helpVC != nil && _helpVC.view != nil )
		{
			[_helpVC.view removeFromSuperview];
			[_helpVC release];
			_helpVC = nil;
		}
		if( _settingsVC != nil && _settingsVC.view != nil )
		{
			[_settingsVC.view removeFromSuperview];
			[_settingsVC release];
			_settingsVC = nil;
		}
	}
	else if( _helpVC.view.superview != nil )
	{
		if( _loadVC != nil && _loadVC.view != nil )
		{
			[_loadVC.view removeFromSuperview];
			[_loadVC release];
			_loadVC = nil;
		}
		if( _creditsVC != nil && _creditsVC.view != nil )
		{
			[_creditsVC.view removeFromSuperview];
			[_creditsVC release];
			_creditsVC = nil;
		}
		if( _settingsVC != nil && _settingsVC.view != nil )
		{
			[_settingsVC.view removeFromSuperview];
			[_settingsVC release];
			_settingsVC = nil;
		}
	}
	else if( _settingsVC.view.superview != nil )
	{
		if( _loadVC != nil && _loadVC.view != nil )
		{
			[_loadVC.view removeFromSuperview];
			[_loadVC release];
			_loadVC = nil;
		}
		if( _creditsVC != nil && _creditsVC.view != nil )
		{
			[_creditsVC.view removeFromSuperview];
			[_creditsVC release];
			_creditsVC = nil;
		}
		if( _helpVC != nil && _helpVC.view != nil )
		{
			[_helpVC.view removeFromSuperview];
			[_helpVC release];
			_helpVC = nil;
		}
	}
	else
	{
		if( _settingsVC != nil && _settingsVC.view != nil )
		{
			[_settingsVC.view removeFromSuperview];
			[_settingsVC release];
			_settingsVC = nil;
		}
		if( _loadVC != nil && _loadVC.view != nil )
		{
			[_loadVC.view removeFromSuperview];
			[_loadVC release];
			_loadVC = nil;
		}
		if( _creditsVC != nil && _creditsVC.view != nil )
		{
			[_creditsVC.view removeFromSuperview];
			[_creditsVC release];
			_creditsVC = nil;
		}
		if( _helpVC != nil && _helpVC.view != nil )
		{
			[_helpVC.view removeFromSuperview];
			[_helpVC release];
			_helpVC = nil;
		}
	}
	
	[ppal1 removeFromSuperview];
	[ppal3 removeFromSuperview];
}

- (void)didReceiveMemoryWarning
{
	//NSLog(@"Gob1MenuViewController didReceiveMemoryWarning");
	
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
	[menuSFXPlayer stop];
	[menuPlayer stop];
	bAnimationOn = false;
	
	//release
	[self releaseView];
	
	if( menuPlayer != nil )
	{
		[menuPlayer release];
		menuPlayer = nil;
	}
	if( menuSFXPlayer != nil )
	{
		[menuSFXPlayer release];
		menuSFXPlayer = nil;
	}
}

- (void)viewDidUnload 
{
	//NSLog(@"Gob1MenuViewController viewDidUnload");
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}

- (void)dealloc 
{
	//NSLog(@"Gob1MenuViewController dealloc");	
    [super dealloc];
	
	if( menuPlayer != nil )
	{
		[menuPlayer release];
		menuPlayer = nil;
	}
	if( menuSFXPlayer != nil )
	{
		[menuSFXPlayer release];
		menuSFXPlayer = nil;
	}
}

-(void) removeMe
{
	[[NSNotificationCenter defaultCenter] postNotificationName:@"loadingScreenOnNotif" object:nil];			
	[self.view removeFromSuperview];
}

-(IBAction) newGameClicked:(id)sender
{
	//NSLog(@"Gob1MenuViewController newGameClicked");		
	bMenuGob1 = false;
	bSimulation = false;
	
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	bSleepMode = false;
	if( bSem )
	{
		sem_post( sem );		
		bSem = false;
	}
	
	if( bFromMenuIngame )
	{
		Gob::GobEngine *gg = (Gob::GobEngine*)[g_iVC getGobEngine]; 
		gg->quitGame();
		
		//release
		[self releaseView];
		
		[NSTimer scheduledTimerWithTimeInterval:0.5 target:self selector:@selector(removeMe) userInfo:nil repeats:NO];
	}
	else
	{		
		[g_switchVC switchViews];	
		[[NSNotificationCenter defaultCenter] postNotificationName:@"loadingScreenOnNotif" object:nil];			
	}
	bAnimationOn = false;
	
	[menuPlayer stop];
}

-(IBAction) loadGameClicked:(id)sender
{
	//NSLog(@"Gob1MenuViewController loadGameClicked");	
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	if (self._loadVC.view.superview == nil) 
	{ 
		if (self._loadVC == nil) 
		{ 
			loadViewController *iii = [[loadViewController alloc] initWithNibName:@"loadViewController" bundle:nil]; 
			self._loadVC = iii; 
			[iii release]; 
		} 
		
		self._loadVC.view.frame = CGRectMake( self._loadVC.view.frame.size.width, 0, self._loadVC.view.frame.size.width, self._loadVC.view.frame.size.height);
		[self.view addSubview:_loadVC.view]; 
		
		[self._loadVC.view setUserInteractionEnabled: NO];
		[UIView beginAnimations:nil context:self]; 
		{
			[UIView setAnimationDuration:1.0];
			[UIView setAnimationDelegate:self];
			[UIView setAnimationDidStopSelector:@selector(showLoadMenuDidEnd:finished:context:)];
			[UIView setAnimationCurve:UIViewAnimationCurveEaseInOut];
			
			self._loadVC.view.frame = CGRectMake( 0, 0, self._loadVC.view.frame.size.width, self._loadVC.view.frame.size.height );
		}
		[UIView commitAnimations];
	}
}

- (void) showLoadMenuDidEnd:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context
{
    [self._loadVC viewDidAppear: YES];
    [self._loadVC.view setUserInteractionEnabled: YES];
}

-(IBAction) settingsClicked:(id)sender
{
	//NSLog(@"Gob1MenuViewController settingsClicked");		
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];

	if (self._settingsVC.view.superview == nil) 
	{ 
		if (self._settingsVC == nil) 
		{ 
			settingsViewController *iii = [[settingsViewController alloc] initWithNibName:@"settingsViewController" bundle:nil]; 
			self._settingsVC = iii; 
			[iii release]; 
		} 
		
		self._settingsVC.view.frame = CGRectMake( self._settingsVC.view.frame.size.width, 0, self._settingsVC.view.frame.size.width, self._settingsVC.view.frame.size.height);
		[self.view addSubview:_settingsVC.view]; 	
		
		[self._settingsVC.view setUserInteractionEnabled: NO];
		[UIView beginAnimations:nil context:self]; 
		{
			[UIView setAnimationDuration:1.0];
			[UIView setAnimationDelegate:self];
			[UIView setAnimationDidStopSelector:@selector(showSettingsMenuDidEnd:finished:context:)];
			[UIView setAnimationCurve:UIViewAnimationCurveEaseInOut];
			
			self._settingsVC.view.frame = CGRectMake( 0, 0, self._settingsVC.view.frame.size.width, self._settingsVC.view.frame.size.height );
		}
		[UIView commitAnimations];
	}
}

- (void) showSettingsMenuDidEnd:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context
{
    [self._settingsVC viewDidAppear: YES];
    [self._settingsVC.view setUserInteractionEnabled: YES];
}

-(IBAction) helpClicked:(id)sender
{
	//NSLog(@"Gob1MenuViewController helpClicked");	
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	if (self._helpVC.view.superview == nil) 
	{ 
		if (self._helpVC == nil) 
		{ 
			helpViewController *iii = [[helpViewController alloc] initWithNibName:@"helpViewController" bundle:nil]; 
			self._helpVC = iii; 
			[iii release]; 
		} 
		
		self._helpVC.view.frame = CGRectMake( self._helpVC.view.frame.size.width, 0, self._helpVC.view.frame.size.width, self._helpVC.view.frame.size.height);
		[self.view addSubview:_helpVC.view]; 	
		
		[self._settingsVC.view setUserInteractionEnabled: NO];
		[UIView beginAnimations:nil context:self]; 
		{
			[UIView setAnimationDuration:1.0];
			[UIView setAnimationDelegate:self];
			[UIView setAnimationDidStopSelector:@selector(showHelpMenuDidEnd:finished:context:)];
			[UIView setAnimationCurve:UIViewAnimationCurveEaseInOut];
			
			self._helpVC.view.frame = CGRectMake( 0, 0, self._helpVC.view.frame.size.width, self._helpVC.view.frame.size.height );
		}
		[UIView commitAnimations];	
	}
}

- (void) showHelpMenuDidEnd:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context
{
    [self._helpVC viewDidAppear: YES];
    [self._helpVC.view setUserInteractionEnabled: YES];
}

-(IBAction) creditsClicked:(id)sender
{
	//NSLog(@"Gob1MenuViewController creditsClicked");		
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	if (self._creditsVC.view.superview == nil)
	{ 
		if (self._creditsVC == nil) 
		{ 
			creditsViewController *iii = [[creditsViewController alloc] initWithNibName:@"creditsViewController" bundle:nil]; 
			self._creditsVC = iii; 
			[iii release]; 
		} 

		self._creditsVC.view.frame = CGRectMake( self._creditsVC.view.frame.size.width, 0, self._creditsVC.view.frame.size.width, self._creditsVC.view.frame.size.height);
		[self.view addSubview:_creditsVC.view]; 	
		
		[self._creditsVC.view setUserInteractionEnabled: NO];
		[UIView beginAnimations:nil context:self]; 
		{
			[UIView setAnimationDuration:1.0];
			[UIView setAnimationDelegate:self];
			[UIView setAnimationDidStopSelector:@selector(showCreditsMenuDidEnd:finished:context:)];
			[UIView setAnimationCurve:UIViewAnimationCurveEaseInOut];
			
			self._creditsVC.view.frame = CGRectMake( 0, 0, self._creditsVC.view.frame.size.width, self._creditsVC.view.frame.size.height );			
		}
		[UIView commitAnimations];			
	}
}

- (void) showCreditsMenuDidEnd:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context
{
    [self._creditsVC viewDidAppear: YES];
    [self._creditsVC.view setUserInteractionEnabled: YES];
}

-(IBAction) moreGamesClicked:(id)sender
{
	//NSLog(@"Gob1MenuViewController moreGamesClicked");	
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	[[UIApplication sharedApplication] openURL:[NSURL URLWithString: @"http://iphone.dotemu.com/"]];
}

@end
