//
//  loadViewController.m
//  scummvm
//
//  Created by DotEmu on 18/05/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#include <semaphore.h>
#import "iphone_common.h"
#import "switchViewController.h"
#import "loadViewController.h"

//////////////////
//---GAME PARAMS
//GAME (GENERAL)
extern bool bLoadingLevel;
extern int idLvLHigh;
//LVL (SIMULATION)
extern bool bSimulation;
extern bool bLvLOneLoaded; 
extern bool bSimulCode;
extern int idLvLToLoad;
extern int etat;
bool bFirstLoad = false;
//GAME
extern int _GobLanguage;
extern bool bMenuGob1;
extern bool bFromMenuIngame;
extern bool bLoadMenu;
//SOUND
extern int idSoundSFX;
extern AVAudioPlayer* menuPlayer;
//DEFINES
extern switchViewController* g_switchVC;
extern Gob1MenuViewController* g_gob1MenuVC;
extern iPhoneViewController* g_iVC;
extern bool bSleepMode;
extern bool bSem;
extern sem_t* sem;
//---END
////////////////

@implementation loadViewController

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

-(void) clearLvLButtons
{
	for( int iid = 0; iid < 21; ++iid )
	{
		if( listLvL[iid] != nil && listLvL[iid].superview != nil )
		{
			[listLvL[iid] removeFromSuperview];
			[listLvL[iid] release];
			listLvL[iid] = nil;
		}
		if( labelLvL[iid] != nil && labelLvL[iid].superview != nil )
		{
			[labelLvL[iid] removeFromSuperview];
			[labelLvL[iid] release];	
			labelLvL[iid] = nil;
		}
	}
}

-(void) loadIngame
{
	etat = 2;
	[[NSNotificationCenter defaultCenter] postNotificationName:@"loadingScreenOnNotif" object:nil];		
	[NSTimer scheduledTimerWithTimeInterval:0.5 target:self selector:@selector(removeMenu) userInfo:nil repeats:NO];
}

-(void) removeMenu
{		
	//release
	[g_gob1MenuVC releaseView];
	[g_gob1MenuVC.view removeFromSuperview];
	bLoadMenu = false;
}

-(IBAction) listLvLClicked:(id)sender
{
	//NSLog(@"loadViewController listLvLClicked");
	for( int i = 0; i < 21; ++i )
	{
		if( listLvL[i] == sender )
		{			
			bMenuGob1 = false;
			bSleepMode = false;
			if( bSem )
			{				
				//NSLog(@"== before post - prio %f ", [[NSThread currentThread] threadPriority] );				
				sem_post( sem );	
				//NSLog(@"== after post - prio %f ", [[NSThread currentThread] threadPriority] );				
				bSem = false;
			}
			[self.view removeFromSuperview];			
			
			if( bFromMenuIngame )
			{
				idLvLToLoad = i+2;
				
				[(iPhoneView*)g_iVC.view addEvent:[[NSDictionary alloc] initWithObjectsAndKeys:[NSNumber numberWithInt:kButtonEscapeDown], @"type",
												  [NSNumber numberWithFloat:0.0f], @"x",[NSNumber numberWithFloat:0.0f], @"y",nil]];
		
				[(iPhoneView*)g_iVC.view addEvent:[[NSDictionary alloc] initWithObjectsAndKeys:[NSNumber numberWithInt:kButtonEscapeUp], @"type",
												  [NSNumber numberWithFloat:0.0f], @"x",[NSNumber numberWithFloat:0.0f], @"y",nil]];
				
				[NSTimer scheduledTimerWithTimeInterval:0.5 target:self selector:@selector(loadIngame) userInfo:nil repeats:NO];				
			}
			else
			{
				idLvLToLoad = i+2;
				bLvLOneLoaded = true;
				bSimulCode = false;
				bLoadingLevel = false;
				bSimulation = true;
				bFirstLoad = true;
					
				[g_switchVC switchViews];	
				[[NSNotificationCenter defaultCenter] postNotificationName:@"loadingScreenOnNotif" object:nil];	
			}
			[menuPlayer stop];
			break;
		}
	}
}

-(void) loadLvL
{
	//NSLog(@"loadViewController loadLvL");	
	int i(0);
	int maxLoop(0);
	switch( etatNext )
	{
		case 0:
			i = 0;
			maxLoop = 4;
			m_prevState.hidden = YES;
			m_nextState.hidden = NO;			
			break;
		case 1:
			i = 4;
			maxLoop = 8;
			m_prevState.hidden = NO;
			m_nextState.hidden = NO;			
			break;
		case 2:
			i = 8;
			maxLoop = 12;
			m_prevState.hidden = NO;
			m_nextState.hidden = NO;			
			break;
		case 3:
			i = 12;
			maxLoop = 16;
			m_prevState.hidden = NO;	
			m_nextState.hidden = NO;			
			break;
		case 4:
			i = 16;
			maxLoop = 20;
			m_prevState.hidden = NO;
			m_nextState.hidden = NO;			
			break;
		case 5:
			i = 20;
			maxLoop = 21;
			m_prevState.hidden = NO;
			m_nextState.hidden = YES;
			break;
	}
	
	//on parcourt la grille pour placer les boutons de niveau
	for( ; i < maxLoop; ++i )
	{
		labelLvL[i] = [[UILabel alloc ] initWithFrame:CGRectMake( 0, 0, 0, 0 )];
		listLvL[i] = [[UIButton buttonWithType:UIButtonTypeCustom] retain];
		
		switch( i%4 )
		{
			case 0:
				if( i == 20 )
				{
					listLvL[i].frame = CGRectMake( 169, 114, 142, 92 );
					if( _GobLanguage == 0 )
						labelLvL[i].frame = CGRectMake( 209, 184, 100, 50 );
					else if( _GobLanguage == 1 )
						labelLvL[i].frame = CGRectMake( 203, 184, 100, 50 );	
				}
				else
				{
					listLvL[i].frame = CGRectMake( 65, 70, 142, 92 );
					if( _GobLanguage == 0 )
						labelLvL[i].frame = CGRectMake( 110, 135, 100, 50 );
					else if( _GobLanguage == 1 )
						labelLvL[i].frame = CGRectMake( 105, 135, 100, 50 );
				}
				break;
			case 1:
				listLvL[i].frame = CGRectMake( 280, 70, 142, 92 );
				if( _GobLanguage == 0 )
					labelLvL[i].frame = CGRectMake( 325, 135, 100, 50 );
				else if( _GobLanguage == 1 )
					labelLvL[i].frame = CGRectMake( 319, 135, 100, 50 );
				break;
			case 2:
				listLvL[i].frame = CGRectMake( 65, 180, 142, 92 );
				if( _GobLanguage == 0 )
					labelLvL[i].frame = CGRectMake( 110, 245, 100, 50 );
				else if( _GobLanguage == 1 )
					labelLvL[i].frame = CGRectMake( 104, 245, 100, 50 );
				break;
			case 3:
				listLvL[i].frame = CGRectMake( 280, 180, 142, 92 );
				if( _GobLanguage == 0 )
					labelLvL[i].frame = CGRectMake( 325, 245, 100, 50 );
				else if( _GobLanguage == 1 )
					labelLvL[i].frame = CGRectMake( 319, 245, 100, 50 );
				break;
		}

		NSString *toss;
		if( _GobLanguage == 0 )
			toss = [NSString stringWithFormat:@"Level %d", i+2];
		else if( _GobLanguage == 1 )
			toss = [NSString stringWithFormat:@"Niveau %d", i+2];
		labelLvL[i].text = toss;
		labelLvL[i].backgroundColor = [UIColor clearColor];
		
		NSString *intString = [NSString stringWithFormat:@"lvl%d.png", i+2];
		[listLvL[i] setImage:[UIImage imageNamed:intString] forState:UIControlStateNormal];
		[listLvL[i] addTarget:self action:@selector(listLvLClicked:) forControlEvents:UIControlEventTouchDown];		
		
		listLvL[i].hidden = NO;
		
		//activation des niveaux debloques
		if( i+2 > idLvLHigh )
		{
			listLvL[i].enabled = NO;
			listLvL[i].alpha = 0.75;
		}
		
		[self.view addSubview:labelLvL[i]];
		[self.view addSubview:listLvL[i]];			
	}
}

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
	//NSLog(@"loadViewController viewDidLoad");		
	bWarning = false;
	m_prevState.hidden = YES;
	m_prevState.exclusiveTouch = YES;
	m_nextState.hidden = NO;
	m_nextState.exclusiveTouch = YES;
	etatNext = 0;
	
	//clear
	[self clearLvLButtons];
	
	//display
	[self loadLvL];
	
	// Emulated CD support through MP3
	NSURL *url = [NSURL fileURLWithPath:[NSString stringWithFormat:@"%@/button-28.mp3", [[NSBundle mainBundle] resourcePath]]];
	NSError *error;
	menuSFXPlayer = [[AVAudioPlayer alloc] initWithContentsOfURL:url error:&error];
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	menuSFXPlayer.numberOfLoops = 0;
	
	bLoadMenu = true;
	
    [super viewDidLoad];
}

// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation 
{
    // Return YES for supported orientations
    return ( interfaceOrientation == UIInterfaceOrientationLandscapeRight || interfaceOrientation == UIInterfaceOrientationLandscapeLeft );
}


- (void)didReceiveMemoryWarning 
{
	//NSLog(@"loadViewController didReceiveMemoryWarning");	
	
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
	bWarning = true;
	[menuSFXPlayer stop];
	if( menuSFXPlayer != nil )
	{
		[menuSFXPlayer release];
		menuSFXPlayer = nil;
	}

	//clear
	[self clearLvLButtons];
}

- (void)viewDidUnload 
{
	//NSLog(@"loadViewController viewDidUnload");
	
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
	if( m_prevState != nil )
	{
		[m_prevState release];
		m_prevState = nil;
	}
	if( m_nextState != nil )
	{
		[m_nextState release];
		m_nextState = nil;
	}
	
	//clear
	for( int iid = 0; iid < 21; ++iid )
	{
		if( listLvL[iid] != nil && listLvL[iid].superview != nil )
		{
			[listLvL[iid] removeFromSuperview];
			[listLvL[iid] release];
			listLvL[iid] = nil;
		}
		if( labelLvL[iid] != nil && labelLvL[iid].superview != nil )
		{
			[labelLvL[iid] removeFromSuperview];
			[labelLvL[iid] release];	
			labelLvL[iid] = nil;
		}
	}
}


- (void)dealloc 
{
	//NSLog(@"loadViewController dealloc");	
    [super dealloc];
	
	if( m_prevState != nil )
	{
		[m_prevState release];
		m_prevState = nil;
	}
	if( m_nextState != nil )
	{
		[m_nextState release];
		m_nextState = nil;
	}
}

- (void)animationFinished:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context 
{
	[self.view removeFromSuperview];
	if( !bWarning )
		[[NSNotificationCenter defaultCenter] postNotificationName:@"animationN" object:nil];		
	else
		bWarning = false;
	
	//clear
	[self clearLvLButtons];
	
	//load
	[self loadLvL];
}

-(IBAction) menuClicked:(id)sender
{
	//NSLog(@"loadViewController menuClicked");
	[menuSFXPlayer stop];	
	menuSFXPlayer.volume = (float)((float)idSoundSFX / 256.0f);
	[menuSFXPlayer play];
	
	[UIView beginAnimations:nil context:self]; 
	{
		[UIView setAnimationDuration:1.0];
		[UIView setAnimationDelegate:self];
		[UIView setAnimationDidStopSelector:@selector(animationFinished:finished:context:)];
		[UIView setAnimationCurve:UIViewAnimationCurveEaseInOut];	
		self.view.frame = CGRectMake( self.view.frame.size.width, 0, self.view.frame.size.width, self.view.frame.size.height );
	}
	[UIView commitAnimations];
}

-(IBAction) nextClicked:(id)sender
{
	//NSLog(@"loadViewController nextClicked");		
	etatNext++;
	
	//clear
	[self clearLvLButtons];
	
	//affichage boutons niveaux
	[self loadLvL];
	
	if( etatNext > 0 )
		m_prevState.hidden = NO;
	if( etatNext == 5 )
		m_nextState.hidden = YES;
}

-(IBAction) prevClicked:(id)sender
{
	//NSLog(@"loadViewController prevClicked");			
	etatNext--;
	
	//clear
	[self clearLvLButtons];
	
	//affichage boutons niveaux
	[self loadLvL];
	
	if( etatNext == 0 )
	{
		m_prevState.hidden = YES;
		m_nextState.hidden = NO;
	}
}

@end
