//
//  switchViewController.m
//  scummvm
//
//  Created by DotEmu on 17/05/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "switchViewController.h"
#import "Gob1MenuViewController.h"
#import "iPhoneViewController.h"
#import "settingsViewController.h"
#import "menuigViewController.h"
#import "iphone_main.h"

//////////////////
//---GAME PARAMS
//GAME (GENERAL)
extern bool bMenuGob1;
extern bool bFromMenuIngame;
//SOUND
extern AVAudioPlayer* menuPlayer;
//DEFINES
extern iPhoneMain* _delegate;
iPhoneViewController* g_iVC;
Gob1MenuViewController* g_gob1MenuVC;
switchViewController* g_switchVC;
menuigViewController* g_menuigVC;
//---END
////////////////

@implementation switchViewController
@synthesize _iVC, _gob1MenuVC, _settingsVC, _menuigVC;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) 
    {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView
{
}
*/

-(void)splashFinished:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context 
{
	//NSLog(@"splashFinished");
	if( imgV != nil )
	{
		[imgV removeFromSuperview];
	}

	if( bMenuGob1 )
	{
		_gob1MenuVC.view.alpha = 0;
		[UIView beginAnimations:nil context:self]; 
		{
			[UIView setAnimationDuration:0.15];
			[UIView setAnimationDelegate:self];
			[UIView setAnimationCurve:UIViewAnimationCurveLinear];
			_gob1MenuVC.view.alpha = 1;
		}
		[UIView commitAnimations];	
		g_gob1MenuVC = _gob1MenuVC;
		g_switchVC = self;
		//[self switchViews];
		
		if( menuPlayer != nil )
			[menuPlayer play];
	}
	else
	{
		[self switchViews];
		[[NSNotificationCenter defaultCenter] postNotificationName:@"loadingScreenOnNotif" object:nil];		
	}
}

-(void)splashBulkyFadeOut
{
	imgV.alpha = 1;
	[UIView beginAnimations:nil context:self]; 
	{
		[UIView setAnimationDuration:0.35];
		[UIView setAnimationDelegate:self];
		[UIView setAnimationCurve:UIViewAnimationCurveLinear];
		[UIView setAnimationDidStopSelector:@selector(splashFinished:finished:context:)];
		imgV.alpha = 0;
	}
	[UIView commitAnimations];
}

-(void)splashBulkyFadeIn
{
	imgV.alpha = 0;
	UIImage *img = [[UIImage alloc] initWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"bulkypix" ofType:@"png"]];
	[imgV setImage:img];
	[img release];
	[UIView beginAnimations:nil context:self]; 
	{
		[UIView setAnimationDuration:0.35];
		[UIView setAnimationDelegate:self];
		[UIView setAnimationCurve:UIViewAnimationCurveLinear];
		if( bMenuGob1 )
			[NSTimer scheduledTimerWithTimeInterval:3 target:self selector:@selector(splashBulkyFadeOut) userInfo:nil repeats:NO];
		else
			[NSTimer scheduledTimerWithTimeInterval:1 target:self selector:@selector(splashBulkyFadeOut) userInfo:nil repeats:NO];
		imgV.alpha = 1;
	}
	[UIView commitAnimations];
}

-(void)splashBulky:(NSString *)animationID finished:(NSNumber *)finished context:(void *)context 
{
	[self splashBulkyFadeIn];
}

-(void) runSwitch
{
	imgV.alpha = 1;
	[UIView beginAnimations:nil context:self]; 
	{
		[UIView setAnimationDuration:0.35];
		[UIView setAnimationDelegate:self];
		[UIView setAnimationCurve:UIViewAnimationCurveLinear];
		[UIView setAnimationDidStopSelector:@selector(splashBulky:finished:context:)];
		imgV.alpha = 0;
	}
	[UIView commitAnimations];
}

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad 
{	
	//NSLog(@"switchViewController viewDidLoad");
	imgV = [[UIImageView alloc] initWithFrame:CGRectMake(0, 0, 480, 320)];	
	UIImage *img = [[UIImage alloc] initWithContentsOfFile:[[NSBundle mainBundle] pathForResource:@"dotemu" ofType:@"png"]];
	[imgV setImage:img];
	[img release];
	
	Gob1MenuViewController *iii = [[Gob1MenuViewController alloc] initWithNibName:@"Gob1MenuViewController" bundle:nil]; 
	self._gob1MenuVC = iii; 
	[iii release]; 
	self._gob1MenuVC.view.alpha = 0;
	[self.view addSubview:self._gob1MenuVC.view];
	g_gob1MenuVC = self._gob1MenuVC;
	
	[self.view addSubview:imgV];
	
	if( menuPlayer != nil )
		[menuPlayer stop];

	if( bMenuGob1 )
		[NSTimer scheduledTimerWithTimeInterval:3 target:self selector:@selector(runSwitch) userInfo:nil repeats:NO];
	else
		[NSTimer scheduledTimerWithTimeInterval:1 target:self selector:@selector(runSwitch) userInfo:nil repeats:NO];
	
    [super viewDidLoad];
}

/*
 screen 1 : Redécouvrez le royaume des Gobliiins / Relive the Gobliiins adventures
 screen 2 : Riez avec leur humour déjanté / Enjoy their funny jokes
 screen 3 : Des interfaces 100% cartoon ! / 100% cartoon interfaces!
 screen 4 : Résolvez l'énigme et passez à la suivante / Solve the puzzle and go on the next
 screen 5 : Explorez l'écran pour trouver de l'aide / Search the screen to have some help!
 */

// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation 
{
    // Return YES for supported orientations
    return ( interfaceOrientation == UIInterfaceOrientationLandscapeRight || interfaceOrientation == UIInterfaceOrientationLandscapeLeft );
}

- (void)didReceiveMemoryWarning 
{
	//NSLog(@"switchViewController didReceiveMemoryWarning");
	
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
	[imgV release];
	imgV = nil;
}

- (void)viewDidUnload 
{
	//NSLog(@"switchViewController viewDidUnload");
	
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc 
{
	//NSLog(@"switchViewController dealloc");	
    [super dealloc];
	
	if( imgV != nil )
	{
		[imgV removeFromSuperview];
		[imgV release];
		imgV = nil;
	}
}

- (void) switchSettingsInGame
{
	//NSLog(@"switchViewController switchSettingsInGame");		
	if (self._settingsVC.view.superview == nil) 
	{ 
		settingsViewController *iii = [[settingsViewController alloc] initWithNibName:@"settingsViewController" bundle:nil]; 
		self._settingsVC = iii; 
		[iii release]; 
		
		[self.view addSubview:_settingsVC.view]; 
	}
}

- (void) switchPause
{
	//NSLog(@"switchViewController switchPause");	
	if (self._menuigVC.view.superview == nil) 
	{ 
		menuigViewController *iii = [[menuigViewController alloc] initWithNibName:@"menuigViewController" bundle:nil]; 
		self._menuigVC = iii; 
		[iii release]; 
		
		self._menuigVC.view.frame = CGRectMake( 165, 10, 150, 250 );
		[self.view addSubview:_menuigVC.view]; 
		g_menuigVC = _menuigVC;
	}
}

- (void) removeMenu
{
	//NSLog(@"switchViewController removeMenu");	
	if( self._gob1MenuVC != nil )
	{ 
		[_gob1MenuVC.view removeFromSuperview];
		[_gob1MenuVC release];
		_gob1MenuVC = nil;
	}
}

- (void) switchMenu
{
	//NSLog(@"switchViewController switchMenu");	
	if (self._gob1MenuVC.view.superview == nil) 
	{ 
		Gob1MenuViewController *iii = [[Gob1MenuViewController alloc] initWithNibName:@"Gob1MenuViewController" bundle:nil]; 
		self._gob1MenuVC = iii; 
		[iii release]; 
		
		[self.view addSubview:_gob1MenuVC.view]; 
		g_gob1MenuVC = _gob1MenuVC;
	}
}

- (void) switchViews
{
	//NSLog(@"switchViewController switchViews");		
	if( bMenuGob1 )
	{
		if( self._gob1MenuVC.view.superview == nil )  
		{ 	
			[self removeMenu];
			
			Gob1MenuViewController *iii = [[Gob1MenuViewController alloc] initWithNibName:@"Gob1MenuViewController" bundle:nil]; 
			self._gob1MenuVC = iii; 
			[iii release]; 
			
			if( !bFromMenuIngame )
			{
				[self._iVC.view removeFromSuperview]; 
			}

			[self.view addSubview:_gob1MenuVC.view]; 
			g_gob1MenuVC = self._gob1MenuVC;
			
			_gob1MenuVC.view.alpha = 0;
			[UIView beginAnimations:nil context:self]; 
			{
				[UIView setAnimationDuration:0.15];
				[UIView setAnimationDelegate:self];
				[UIView setAnimationCurve:UIViewAnimationCurveLinear];
				_gob1MenuVC.view.alpha = 1;
			}
			[UIView commitAnimations];
		}
	}
	else
	{
		if (self._iVC.view.superview == nil) 
		{ 
			iPhoneViewController *iii = [[iPhoneViewController alloc] initWithNibName:@"iPhoneViewController" bundle:nil]; 
			self._iVC = iii; 
			[iii release];  
			
			//release
			[_gob1MenuVC releaseView];
			
			[_gob1MenuVC.view removeFromSuperview]; 
			
			if( !bFromMenuIngame )
			{
				[self.view addSubview:_iVC.view];
				g_iVC = self._iVC;
			}
			
			//methods
			[[NSNotificationCenter defaultCenter] addObserver:_delegate
													 selector:@selector(didRotate:)
														 name:@"UIDeviceOrientationDidChangeNotification" 
													   object:nil];
			
			[NSThread detachNewThreadSelector:@selector(mainLoop:) 
									 toTarget:_delegate
								   withObject:nil];
		}
	}
	
	//recup top view
	g_switchVC = self;
}


@end
